<?php
session_start();
/*
  Plugin Name: Mindstien Quick Login
  Plugin URI: http://www.mindstien.com/
  Version: 1.0
  Author: Mindstien Technologies
  Author URI: http://www.mindstien.com/
  Description: Get freedom from boring login system, remembering username passwords for multiple wp blogs, just remember one name (secret code) and get quick login to any of your wp site via quick login link received in email.
  Copyright @2013 Mindstien Technologies
 */

add_action('admin_menu', 'mql_menu');

function mql_menu() {
	add_options_page( "Mindstien Quick Login", "Quick Login", "administrator", "mquick-login", "mquick_login_options");
} 
function mquick_login_options()
{

	if(isset($_POST['mql_form_secret']) AND $_POST['mql_form_secret'] == $_SESSION['mql_form_secret'])
	{
		//settings form submitted, save it.
		global $user_ID;
		update_option('mql_userID',$user_ID);
		update_option("mql_secret",trim($_POST['mql_secret']));
		echo "<div class='updated'><p>Settings saved!</p></div>";
	}

	//update_option("mql_secret","XXXX");
	$mql_secret = get_option("mql_secret");
	$secret = md5(time());
	$_SESSION['mql_form_secret'] = $secret;
	?>	
		<div class='wrap'>
			<h2>Mindstien Quick Login Options</h2>
			<p><strong>How this works ?</strong></p>
			<p>Save your secret code below, it should be easy to remember for you. Secret code does not have to be strong like password its for you so you can remember easily. To login, visit your site with ?x=ZZZZ at the end of url, where ZZZZ is the secret code you just saved. You will soon receive the email containing the quick login link on your registered email address. You can click on the link and you will be taken direct to your wp-admin dashboard (bypassing login form).</p>
			<p><strong>Why This Plugin ?</strong></p>
			<p>If you are one of those people who think why they need this plugin, why cant they just login using username/passwords ? Well, personally I manage multiple wordpress blogs and I have to keep the password strong and different for each blog for security purpose, now its always become hard for me to remember the password and each time I forget password, either I have to go through the forget passwords link. Some time I also forget username too (b'cos I don't use default username as 'admin' or my own name for security purpose), in such cases I go to the wordpress database via phpmyadmin (cpanel) and reset the username/password there. So that is why this plugin... Enjoy the safest and easiest way of quick login without need of remembering those ugly (yet strong) passwords.</p>
			<p><strong>Is it safe ?</strong></p>
			<p>Yes, its safe because 
				<ol>
					<li>Only you will know the secret code, </li>
					<li>It will send email to only that user's email who has saved secret code (you)</li>
					<li>The quick login link in your email will only work for you, ie. link will be valid for the same computer, same browser and same browser session and only once. Link will do nothing if you visit from different computer/browser etc. Link will work only once.</li>
					<li>Still confused ? <a href='http://mindstien.com/contact-us/' target='_blank'>Contact Us</a> to send your questions</li>
				</ol>
			</p>
			<p><strong>Got question or suggestion ?</strong></p>
			<p>Your questions and suggestions are very valuable to us, as they help us improve our work and to serv you better. Please <a href='http://mindstien.com/contact-us/' target='_blank'>Contact Us</a> to send your valuable inputs.</p>
			<p>&nbsp;</p>
			<p><strong>Settings:</strong></p>
			<p>Your login url: <code><?php echo site_url("?x=$mql_secret"); ?></code> <strong>Bookmark</strong> this for future use.</p>
			<form method='post'>
				<input type='hidden' name='mql_form_secret' value='<?php echo $secret; ?>'>
				<label for='secret'>Secret Code:</label>
				<input type='text' name='mql_secret' value='<?php echo $mql_secret; ?>'>
				<input type=submit name="submit" value="Save Settings" class='button-primary'>
			</form>
		</div>
	<?php
}


add_action('init','mql_init'); 
function mql_init()
{
	$mql_secret = get_option('mql_secret');
	if(isset($_GET['x']) AND $_GET['x'] == $mql_secret)
	{
		$pass = md5(time());
		$_SESSION['mql_pass']= $pass;
		$user_id = get_option('mql_userID');
		$user = get_user_by('id', $user_id );
		if(!is_wp_error($user))
		{
			add_filter( 'wp_mail_content_type', 'mql_set_html_content_type' );

			wp_mail( $user->user_email, 'Your Quick Login Link For "'.get_bloginfo('name').'"', '<p>Dear '.$user->display_name.', <br>Please find your Quick Login Link below.</p><p><strong>Quick Login Url:</strong> <a href="'.site_url("?mql_pass=$pass").'">'.site_url("?mql_pass=$pass").'</a></p><p>From:<br>Mindstien Quick Login Plugin on "'.get_bloginfo('name').'"</p>');

			// Reset content-type to avoid conflicts -- http://core.trac.wordpress.org/ticket/23578
			remove_filter( 'wp_mail_content_type', 'mql_set_html_content_type' );
		}
	}
	
	if(isset($_GET['mql_pass']) AND $_GET['mql_pass'] == $_SESSION['mql_pass'])
	{
		// Automatic login //
		$user_id = get_option('mql_userID');
		$user = get_user_by('id', $user_id );

		// Redirect URL //
		if ( !is_wp_error( $user ) )
		{
			unset($_SESSION['mql_pass']);
			wp_clear_auth_cookie();
			wp_set_current_user ( $user->ID );
			wp_set_auth_cookie  ( $user->ID );
			$redirect_to = user_admin_url();
			
			wp_safe_redirect( $redirect_to );
			exit();
		}
	}
}

function mql_set_html_content_type() {
	return 'text/html';
}
?>